<?php

if (!defined('IN_DISCUZ')) {
    exit('error');
}

class plugin_baidupan_base {

    protected $table         = 'baidupan';
    protected $task         = 'baidupan_task';
    protected $token        = null;
    protected $unused       = 'forum_attachment_unused';
    protected $save_dir     = '/apps/gbk.dehua.me/baidupan/';
    protected $is_open      = false;
    protected $cache_file   = 'cache_hacktor_baidupan.php';
    protected $ext          = array('jpg', 'gif', 'jpeg', 'bmp', 'png');
    protected $auto_delete  = false;
    protected $attach       = false;
    protected $dir;
    protected $sdk;
    
    function __construct() {
        global $_G;
        $hacktor_baidupan   = $_G['cache']['plugin']['hacktor_baidupan'];
        
        $this->auto_delete  = $hacktor_baidupan['auto_delete'];
        $this->dir      = DISCUZ_ROOT.'source/plugin/hacktor_baidupan/';
        $this->sdk      = $this->dir.'sdk/BaiduPCS.class.php';
        $this->attach   = $_G['setting']['attachurl'].'forum/';
        
        $file           = DISCUZ_ROOT . 'data/sysdata/'.$this->cache_file;
        //ļ
        if(file_exists($file)){
            include $file;
            $this->is_open  = true;
            $this->token    = $access_token;
        }
    }
    
    /**
     * Զɾƻ
     * @param type $aid
     * @param type $path
     */
    function add_task($aid, $path){
        $path   = str_replace('\\', '/', $path);
        $time   = date('Y-m-d', time()).' 23:59:59';
        $data   = array('aid'=>$aid, 'path'=>$path,'execute_at'=>  strtotime($time));
        $sql    = 'select aid from '.DB::table($this->task) . ' where aid='.$aid;
        $exist  = DB::fetch_first($sql) ;
        if(empty($exist)){
            DB::insert($this->task, $data);
        }
    }
    
    /**
     * ִɾƻ
     * @return boolean
     */
    function execute_task(){
        $time   = time();
        $sql    = 'select * from '.DB::table($this->task) .' where execute_at <='.$time.' limit 50';
        $result = DB::fetch_all($sql);
        if(empty($result)){
            return true;
        }
        $aids   = array();
        foreach ($result as $key => $value) {
            $path   = $value['path'];
            if(!file_exists($path)){
                $aids[] = $value['aid'];
                continue;
            }
            if(unlink($path)){
                $aids[] = $value['aid'];
            }
        }
        //ɾ
        if(!empty($aids)){
            $sql    = 'delete from '.DB::table($this->task).' where aid in('.  implode(',', $aids).')';
            DB::query($sql);
        }
    }
    
    protected function get_http_url($url){
        $http   = 'plugin.php?id=hacktor_baidupan:get&url=';
        $http   = $http . base64_encode(authcode($url, 'ENCODE'));
        return $http;
    }

    /**
     * 
     * @param type $path
     * @return type
     */
    function get_pic_by_path($path) {
        $sql = "select status from " . DB::table($this->table);
        $sql = $sql . " where path='$path'";
        $fetch = DB::fetch_first($sql);
        return $fetch;
    }

    function detlete_batch_by_aid($aids) {
        $sql = 'delete from ' . DB::table($this->table);
        $sql = $sql . ' where aid in (' . $aids . ')';
        DB::query($sql);
    }

    /**
     * δʹ
     * @param type $aid
     * @return type
     */
    function get_pic_by_aid($aid) {
        $sql = "select * from " . DB::table($this->table);
        $sql = $sql . " where aid=" . $aid;
        $fetch = DB::fetch_first($sql);
        return $fetch;
    }

    /**
     * δʹ
     * @param type $tableid
     * @param type $aid
     * @return type
     */
    function get_attachment($tableid, $aid) {
        $table = 'forum_attachment_' . substr($tableid, -1);
        $sql = "select attachment from " . DB::table($table);
        $sql = $sql . ' where aid=' . $aid;
        return DB::fetch_first($sql);
    }

    function get_unused_attachment($aid) {
        return C::t($this->unused)->fetch($aid);
    }

    /**
     * ͼƬϴ
     * @param BaiduPCS $pcs 
     * @param string $attach DISCUZ_ROOT .  $_G['setting']['attachurl'].'forum/'
     * @param string $attachment  201303/01/001702lzc2vy6j80wub85h.jpg
     * @param int $aid  1
     */
    function upload_pic(BaiduPCS $pcs, $attach, $attachment, $aid = 1) {

        //ļַ
        $fileContent = file_get_contents($attach . $attachment);
        //ϴļĿ걣·
        $targetPath = $this->save_dir . $attachment;
        $targetPath = explode('/', $targetPath);
        array_pop($targetPath);
        $targetPath = implode('/', $targetPath) . '/';
        $fileName = basename($attachment);
        $upload = $pcs->upload($fileContent, $targetPath, $fileName);
        $is_succeed = $this->is_succeed($upload);
        $data = array('status' => $is_succeed, 'path' => $attachment, 'aid' => $aid);
        //Զɾļ
        if($is_succeed && $this->auto_delete =='open'){
            $this->add_task($aid, $attach . $attachment);
        }
        DB::insert($this->table, $data);
    }

    /**
     * ϴж
     * @param type $upload
     * @return int
     */
    function is_succeed($upload) {
        $upload = json_decode($upload, true);
        if (isset($upload['error_code']) && $upload['error_code'] == 31061) {
            return 1;
        }
        if (isset($upload['fs_id'])) {
            return 1;
        }
        return 0;
    }

    /**
     * ͼƬ
     * @param BaiduPCS $pcs
     * @param type $attchurl
     * @param type $message
     * @return type
     */
    function baidupan_message(BaiduPCS $pcs, $attchurl, $message) {

        $pattern = '~zoomfile="' . $attchurl . '(.*?)"~';
        preg_match_all($pattern, $message, $matches);

        if (!isset($matches[1]) || empty($matches[1])) {
            return $message;
        }
        
        //ͼƬ
        $pre = 'forum.php?mod=attachment';
        preg_match_all('~<a href="forum.php\?mod=attachment(.*?)"~', $message, $attachments);

        //ƥͼƬ
        preg_match_all('~<img id="aimg_(\d+)"~', $message, $aids);

        foreach ($matches[1] as $key => $value) {
            $value = addslashes($value);
            $aid = addslashes($aids[1][$key]);

            $pic = $this->get_pic_by_aid($aid);
            if (empty($pic)) {
                $this->upload_pic($pcs, $attchurl, $value, $aid);
                continue;
            }
            if (!$pic['status']) {
                continue;
            }
            $replace = $attchurl . $value;
            $http = $pcs->getDownUrl($this->save_dir . $value);
            $http   = $this->get_http_url($http);
            $message = str_replace($replace, $http, $message);
            //滻
            $message = str_replace($pre . $attachments[1][$key], $http, $message);
        }
        return $message;
    }

}

?>
