<?php

/**
 * @desc PCSļݽӿSDK, ҪPHPлΪ5.2.0
 * @package  baidu.pcs
 * @author   duanzhenxing(duanzhenxing@baidu.com)
 * @version  2.1.0
 */
require_once dirname ( __FILE__ ) . '/' . 'RequestCore.class.php';

/**
 * @desc BaiduPCS
 */
class BaiduPCS {

	/**
	 * ٶPCS RESTFUL API SERVERõַǰ׺
	 * @var array
	 */
	private $_pcs_uri_prefixs = array ('https' => 'https://pcs.baidu.com/rest/2.0/pcs/' );

	private $_accessToken = '';

	/**
	 * ʼaccessToken
	 * @param string $accessToken
	 */
	public function __construct($accessToken) {
		$this->_accessToken = $accessToken;
	}

	/**
	 * accessToken
	 * @param string $_accessToken
	 * @return BaiduPCS
	 */
	public function setAccessToken($accessToken) {
		$this->_accessToken = $accessToken;
		return $this;
	}

	/**
	 * ȡaccessToken
	 * @return string
	 */
	public function getAccessToken() {
		return $this->_accessToken;
	}

	/**
	 * API
	 * @param string $apiMethod api
	 * @param array || string  $params 
	 * @param string $method HTTP
	 * @param string $headers ӵHTTP HEADERϢ
	 * @return string
	 */
	private function _baseControl($apiMethod, $params, $method = 'GET', $headers = array()) {

		$method = strtoupper ( $method );

		if (is_array ( $params )) {
			$params = http_build_query ( $params, '', '&' );
		}

		$url = $this->_pcs_uri_prefixs ['https'] . $apiMethod . ($method == 'GET' ? '&' . $params : '');

		$requestCore = new RequestCore ();
		$requestCore->set_request_url ( $url );

		$requestCore->set_method ( $method );
		if ($method == 'POST') {
			$requestCore->set_body ( $params );
		}

		foreach ( $headers as $key => $value ) {
			$requestCore->add_header ( $key, $value );
		}

		$requestCore->send_request ();
		$result = $requestCore->get_response_body ();

		return $result;
	}

	/**
	 * ȡǰûռϢ
	 * @return string
	 */
	public function getQuota() {
		$result = $this->_baseControl ( 'quota?method=info' . '&access_token=' . $this->_accessToken, array () );
		return $result;
	}

	/**
	 * ϴļ
	 * ע⣺˷ϴ2Gĵļ
	 * @param string $fileContent ļַ
	 * @param string $targetPath ϴļĿ걣·
	 * @param string $fileName ļ
	 * @param string $newFileName ļ
	 * @param boolean $isCreateSuperFile ǷƬϴ
	 * @return string
	 */
	public function upload($fileContent, $targetPath, $fileName, $newFileName = null, $isCreateSuperFile = FALSE) {
		$boundary = md5 ( time () );
		$postContent .= "--" . $boundary . "\r\n";
		$postContent .= "Content-Disposition: form-data; name=\"file\"; filename=\"{$fileName}\"\r\n";
		$postContent .= "Content-Type: application/octet-stream\r\n\r\n";
		$postContent .= $fileContent . "\r\n";
		$postContent .= "--" . $boundary . "\r\n";

		$requestStr = 'file?method=upload&path=' . urlencode ( $targetPath . (empty ( $newFileName ) ? $fileName : $newFileName) ) . '&access_token=' . $this->_accessToken;

		if ($isCreateSuperFile === TRUE) {
			$requestStr .= '&type=tmpfile';
		}

		$result = $this->_baseControl ( $requestStr, $postContent, 'POST', array ('Content-Type' => 'multipart/form-data; boundary=' . $boundary ) );
		return $result;
	}

	/**
	 * ϲƬϴļ
	 * ע⣺зƬļ飬Եuploadӿڰ˳ϴ֮
	 * ٵcreateSuperFileӿڽļϲļ˷һڳļ>2G
	 * @param string $targetPath ϴļĿ걣·
	 * @param string $fileName ļ
	 * @param array $params Ƭļmd5ֵ
	 * @param string $newFileName ļ
	 * @return string
	 */
	public function createSuperFile($targetPath, $fileName, array $params, $newFileName = null) {
		$result = $this->_baseControl ( 'file?method=createsuperfile&path=' . urlencode ( $targetPath . (empty ( $newFileName ) ? $fileName : $newFileName) ) . '&access_token=' . $this->_accessToken, array ('param' => json_encode ( array ('block_list' => $params ) ) ), 'POST' );
		return $result;
	}

	/**
	 * ļ
	 * @param string $path ļ·
	 * @return ļ
	 */
	public function download($path) {
		$result = $this->_baseControl ( 'file?method=download' . '&access_token=' . $this->_accessToken, array ('path' => $path ), 'GET' );
		return $result;
	}

	/**
	 * ļ
	 * @param string $path ļ·
	 * @return string
	 */
	public function makeDirectory($path) {
		$result = $this->_baseControl ( 'file?method=mkdir' . '&access_token=' . $this->_accessToken, array ('path' => $path ), 'POST' );
		return $result;
	}

	/**
	 * ȡļ/Ŀ¼metaϢ
	 * @param string $path ļ·
	 * @return string
	 */
	public function getMeta($path) {
		$result = $this->_baseControl ( 'file?method=meta' . '&access_token=' . $this->_accessToken, array ('path' => $path ) );
		return $result;
	}

	/**
	 * ȡļ/Ŀ¼metaϢ
	 * @param array $paths ļ·
	 * @return string
	 */
	public function getBatchMeta(array $paths) {
		$list = array ();
		foreach ( $paths as $value ) {
			array_push ( $list, array ('path' => $value ) );
		}
		$list = array ('list' => $list );
		$list = json_encode ( $list );
		$result = $this->_baseControl ( 'file?method=meta' . '&access_token=' . $this->_accessToken, array ('param' => $list ), 'POST' );
		return $result;
	}

	/**
	 * ȡָļµļб
	 * @param string $path ļ·
	 * @param string $by ֶΣȱʡļtime޸ʱ䣩nameļsizeСעĿ¼޴С
	 * @param string $order ascdescȱʡý
	 * @param string $limit ĿƣʽΪn1-n2ؽ[n1, n2)֮ĿȱʡĿn10ʼ
	 * @return string
	 */
	public function listFiles($path, $by = 'name', $order = 'asc', $limit = '0-9') {
		$result = $this->_baseControl ( 'file?method=list' . '&access_token=' . $this->_accessToken, array ('path' => $path, 'by' => $by, 'order' => $order, 'limit' => $limit ) );
		return $result;
	}

	/**
	 * ƶļ/Ŀ¼
	 * @param string $from Դ·
	 * @param string $to Ŀ·
	 * @return string
	 */
	public function moveSingle($from, $to) {
		$result = $this->_baseControl ( 'file?method=move' . '&access_token=' . $this->_accessToken, array ('from' => $from, 'to' => $to ), 'POST' );
		return $result;
	}

	/**
	 * ƶļ/Ŀ¼
	 * @param array $from Դ·
	 * @param array $to Ŀ·
	 * @return string
	 */
	public function moveBatch(array $from, array $to) {
		$list = array ();
		for($i = 0; $i < count ( $from ); $i ++) {
			array_push ( $list, array ('from' => $from [$i], 'to' => $to [$i] ) );
		}
		$list = array ('list' => $list );
		$list = json_encode ( $list );
		$result = $this->_baseControl ( 'file?method=move' . '&access_token=' . $this->_accessToken, array ('param' => $list ), 'POST' );
		return $result;
	}

	/**
	 * ļ/Ŀ¼
	 * @param string $from Դ·
	 * @param string $to Ŀ·
	 * @return string
	 */
	public function copySingle($from, $to) {
		$result = $this->_baseControl ( 'file?method=copy' . '&access_token=' . $this->_accessToken, array ('from' => $from, 'to' => $to ), 'POST' );
		return $result;
	}

	/**
	 * ļ/Ŀ¼
	 * @param array $from Դ·
	 * @param array $to Ŀ·
	 * @return string
	 */
	public function copyBatch(array $from, array $to) {
		$list = array ();
		for($i = 0; $i < count ( $from ); $i ++) {
			array_push ( $list, array ('from' => $from [$i], 'to' => $to [$i] ) );
		}
		$list = array ('list' => $list );
		$list = json_encode ( $list );

		$result = $this->_baseControl ( 'file?method=copy' . '&access_token=' . $this->_accessToken, array ('param' => $list ), 'POST' );
		return $result;
	}

	/**
	 * ɾļ/Ŀ¼
	 * @param string $path ļ·
	 * @return string
	 */
	public function deleteSingle($path) {
		$result = $this->_baseControl ( 'file?method=delete' . '&access_token=' . $this->_accessToken, array ('path' => $path ), 'POST' );
		return $result;
	}

	/**
	 * ɾļ/Ŀ¼
	 * @param array $paths ļ·
	 * @return string
	 */
	public function deleteBatch(array $paths) {
		$list = array ();
		foreach ( $paths as $value ) {
			array_push ( $list, array ('path' => $value ) );
		}
		$list = array ('list' => $list );
		$list = json_encode ( $list );

		$result = $this->_baseControl ( 'file?method=delete' . '&access_token=' . $this->_accessToken, array ('param' => $list ), 'POST' );
		return $result;
	}

	/**
	 * ļļ
	 * @param string $path ļ·
	 * @param string $wd ؼ
	 * @param int $re Ƿݹ
	 * @return string
	 */
	public function search($path, $wd, $re = 1) {
		$result = $this->_baseControl ( 'file?method=search' . '&access_token=' . $this->_accessToken, array ('path' => $path, 'wd' => $wd, 're' => $re ) );
		return $result;
	}

	/**
	 * ͼ
	 * @param string $path ͼƬ·
	 * @param int $width
	 * @param int $height
	 * @param int32 $quality
	 * @return ļ
	 */
	public function thumbnail($path, $width, $height, $quality = 100) {
		$result = $this->_baseControl ( 'thumbnail?method=generate' . '&access_token=' . $this->_accessToken, array ('path' => $path, 'width' => $width, 'height' => $height, 'quality' => $quality ), 'GET' );
		return $result;
	}

	/**
	 * ļ²ѯ
	 * @param string $cursor ڱǸ¶ϵ㡣״εcursor=null״εãʹһεdiffӿڵķؽеcursor
	 * @return string
	 */
	public function diff($cursor) {
		$result = $this->_baseControl ( 'file?method=diff' . '&access_token=' . $this->_accessToken, array ('cursor' => $cursor ) );
		return $result;
	}

	/**
	 * Ϊǰûһʽļ
	 * @param string $path
	 * @return ļ
	 */
	public function downloadStream($path) {
		$result = $this->_baseControl ( 'stream?method=download' . '&access_token=' . $this->_accessToken, array ('path' => $path ) );
		return $result;
	}

	/**
	 * ȡӦĿ¼ʽļб
	 * @param string $type ȡֵΪvideoaudioimagedoc
	 * @param string $start
	 * @param string $limit
	 * @param string $filterPath
	 * @return string
	 */
	public function listStream($type, $start = 0, $limit = '1000', $filterPath = '') {
		$result = $this->_baseControl ( 'stream?method=list' . '&access_token=' . $this->_accessToken, array ('type' => $type, 'start' => $start, 'limit' => $limit, 'filter_path' => $filterPath ) );
		return $result;
	}

	/**
	 * ΪǰûƵת벢ʵʵʱۿ
	 * @param string $path ʽΪm3u8,m3u,asf,avi,flv,gif,mkv,mov,mp4,m4a,3gp,3g2,mj2,mpeg,ts,rm,rmvb,webm
	 * @param string $type M3U8_320_240M3U8_480_224M3U8_480_360M3U8_640_480M3U8_854_480
	 * @return ļбURL
	 */
	public function streaming($path, $type) {
		$result = $this->_baseControl ( 'file?method=streaming' . '&access_token=' . $this->_accessToken, array ('path' => $path, 'type' => $type ) );
		return $result;
	}

	/**
	 * 봫һļ
	 * ע
	 * 1. 봫ļ256KB 256*1024 B
	 * 2. УΪļǰ256KB봫ӿҪṩ봫ļCRC32УεMD5
	 * @param string $path
	 * @param int $contentLength
	 * @param string $contentMd5
	 * @param string $sliceMd5
	 * @param string $contentCrc32
	 * @return string
	 */
	public function cloudMatch($path, $contentLength, $contentMd5, $sliceMd5, $contentCrc32) {
		$result = $this->_baseControl ( 'file?method=rapidupload' . '&access_token=' . $this->_accessToken, array ('path' => $path, 'content-length' => $contentLength, 'content-md5' => $contentMd5, 'slice-md5' => $sliceMd5, 'content-crc32' => $contentCrc32 ) );
		return $result;
	}

	/**
	 * 
	 * @param string $savePath PCSдŵ·
	 * @param string $sourceUrl ҪݵURL
	 * @param int $rateLimit ٶȣ byte/s
	 * @param int $timeout صĳʱʱ
	 * @param string $callback صURLص̲302ת
	 * @param int $expires ʧЧʱ
	 * @return string
	 */
	public function addOfflineDownloadTask($savePath, $sourceUrl, $rateLimit = '', $timeout = 3600, $callback='', $expires = ''){
		$result = $this->_baseControl ( 'services/cloud_dl?method=add_task' . '&access_token=' . $this->_accessToken, array ('save_path' => $savePath, 'source_url' => $sourceUrl, 'rate_limit' => $rateLimit, 'timeout' => $timeout, 'callback' =>$callback ), 'POST' );
		return $result;
	}

	/**
	 * ȷѯ
	 * @param string $taskIds Ҫѯtask_idб磺'1,2,3,4'
	 * @param int $expires ʧЧʱ
	 * @param int $opType 0Ϣ1Ϣ
	 * @return string
	 */
	public function queryOfflineDownloadTask($taskIds, $opType = 1, $expires = ''){
		$result = $this->_baseControl ( 'services/cloud_dl?method=query_task' . '&access_token=' . $this->_accessToken, array ('task_ids' => $taskIds, 'op_type' => $opType) );
		return $result;
	}

	/**
	 * ѯб
	 * @param int $start ʼλ
	 * @param int $limit ضٸ
	 * @param int $asc ʼʱ or 
	 * @param string $sourceURL ĿַURL
	 * @param string $savePath ·
	 * @param string $createTime STARTTIMESTMAP, ENDTIMESTAMP, ޿д"NULL, 1235", ߣд'1234,NULL'
	 * @param int $status ״̬
	 * @param int $needTaskInfo ǷҪϢ
	 * @param int $expires ʧЧʱ
	 * @return string
	 */
	public function listOfflineDownloadTask($start = 0, $limit = 10, $asc = 0, $sourceURL = '', $savePath = '', $createTime = '', $status = 1, $needTaskInfo = 1, $expires = ''){
		$result = $this->_baseControl ( 'services/cloud_dl?method=list_task' . '&access_token=' . $this->_accessToken,
				array ('start' => $start, 'limit' => $limit, 'asc' => $asc, 'source_url' => $sourceURL,
						'save_path' => $savePath, 'create_time' => $createTime, 'status' => $status, 'need_task_info' =>$needTaskInfo), 'POST' );
		return $result;
	}

	/**
	 * ȡ
	 * @param int $taskId ҪȡId
	 * @param int $expires ʧЧʱ
	 * @return string
	 */
	public function cancelOfflineDownloadTask($taskId, $expires = ''){
		$result = $this->_baseControl ( 'services/cloud_dl?method=cancel_task' . '&access_token=' . $this->_accessToken, array ('task_id' => $taskId) );
		return $result;
	}
        
        public function getDownUrl($path){
            $http   = $this->_pcs_uri_prefixs['https'].'file?method=download&access_token='.$this->_accessToken;
            $http   = $http. '&path='.  urlencode($path);
            return $http;
        }
}
?>